%ifarch %{ix86}
%define target linux
%endif
%ifarch x86_64
%define target linux-64
%endif
%ifarch ppc ppc64 sparc sparc64 alpha
%define target linux-%{_target_cpu}
%endif

%define variants thr thr-ogl lam lam-ogl

Summary: Parallel / Multiprocessor Ray Tracing System
Name: tachyon
Version: 0.98.1
Release: 1%{?dist}
URL: http://jedi.ks.uiuc.edu/~johns/raytracer/
Group: Applications/Engineering
Source: http://jedi.ks.uiuc.edu/~johns/raytracer/files/%{version}/%{name}-%{version}.tar.gz
Patch0: %{name}-rpm.patch
License: BSD with advertising
BuildRoot: %{_tmppath}/%{name}-%{version}-root-%(%{__id_u} -n)
BuildRequires: environment-modules
BuildRequires: libGLU-devel
BuildRequires: libpng-devel
BuildRequires: libjpeg-devel
BuildRequires: lam-devel
BuildRequires: latex2html
BuildRequires: %{_bindir}/dvips
BuildRequires: %{_bindir}/latex
BuildRequires: %{_bindir}/pdflatex

%description
A portable, high performance parallel ray tracing system supporting MPI
and multithreaded implementations.  Tachyon is built as a C callable
library, which can be used with the included demo programs or within
your own application.  The distribution also includes a simple scene
file parser front-end which reads a few different formats.

This package contains pthread build.

%package gl
Summary: Parallel / Multiprocessor Ray Tracing System with OpenGL display
Group: Applications/Engineering
Provides: %{name} = %{version}-%{release}

%description gl
A portable, high performance parallel ray tracing system supporting MPI
and multithreaded implementations.  Tachyon is built as a C callable
library, which can be used with the included demo programs or within
your own application.  The distribution also includes a simple scene
file parser front-end which reads a few different formats.

This package contains pthread build with OpenGL display.

%package lam
Summary: Parallel / Multiprocessor Ray Tracing System
Group: Applications/Engineering
Provides: %{name} = %{version}-%{release}

%description lam
A portable, high performance parallel ray tracing system supporting MPI
and multithreaded implementations.  Tachyon is built as a C callable
library, which can be used with the included demo programs or within
your own application.  The distribution also includes a simple scene
file parser front-end which reads a few different formats.

This package contains LAM build.

%package lam-gl
Summary: Parallel / Multiprocessor Ray Tracing System with OpenGL display
Group: Applications/Engineering
Provides: %{name} = %{version}-%{release}

%description lam-gl
A portable, high performance parallel ray tracing system supporting MPI
and multithreaded implementations.  Tachyon is built as a C callable
library, which can be used with the included demo programs or within
your own application.  The distribution also includes a simple scene
file parser front-end which reads a few different formats.

This package contains LAM build with OpenGL display.

%package docs
Summary: Documentation and example scenes for tachyon
Group: Documentation
Requires: %{name} = %{version}-%{release}

%description docs
This package contains documentation and example scenes for rendering
with tachyon.

%prep
%setup -q -n %{name}
%patch0 -p1 -b .r
find . -name CVS | xargs %{__rm} -r
# executable sources
chmod 644 src/hash.{c,h}
chmod 644 demosrc/trackball.c
# pre-built binaries
rm -r compile/{linux,solaris}/*
# dangling symlinks
rm scenes/{imaps,tpoly,vol}

%build
. /etc/profile.d/modules.sh
module load %{_libdir}/lam/lam.module
pushd unix
for variant in %{variants} ; do
  %{__make} %{?_smp_mflags} OPTFLAGS="$RPM_OPT_FLAGS" %{target}-$variant
done
popd

pushd docs
%{__make} html pdf ps
popd

%install
%{__rm} -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT{%{_bindir},%{_datadir}/tachyon}
for variant in %{variants} ; do
  install -pm755 compile/%{target}-$variant/tachyon $RPM_BUILD_ROOT%{_bindir}/tachyon-$variant
done
rename -thr "" $RPM_BUILD_ROOT%{_bindir}/*
%{__mv} docs/tachyon docs/html
%{__cp} -pr scenes $RPM_BUILD_ROOT%{_datadir}/tachyon/

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc Changes Copyright README
%attr(755,root,root) %{_bindir}/%{name}

%files gl
%defattr(644,root,root,755)
%doc Changes Copyright README
%attr(755,root,root) %{_bindir}/%{name}-ogl

%files lam
%defattr(644,root,root,755)
%doc Changes Copyright README
%attr(755,root,root) %{_bindir}/%{name}-lam

%files lam-gl
%defattr(644,root,root,755)
%doc Changes Copyright README
%attr(755,root,root) %{_bindir}/%{name}-lam-ogl

%files docs
%defattr(644,root,root,755)
%doc docs/tachyon.pdf docs/tachyon.ps docs/html
%{_datadir}/tachyon

%changelog
* Sat Feb 28 2009 Dominik 'Rathann' Mierzejewski <rpm@greysector.net> 0.98.1-1
- update to 0.98.1 release
- fix mixed-up summaries
- docs are now built separately

* Wed Feb 25 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.98-0.8.20070319
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Fri Sep 26 2008 Dominik 'Rathann' Mierzejewski <rpm@greysector.net> 0.98-0.7.20070319
- fix build with new lam package
- use generic BR for libGLU-devel
- move tree cleanup to %%prep to fix short-circuit builds

* Tue Feb 19 2008 Fedora Release Engineering <rel-eng@fedoraproject.org> - 0.98-0.6.20070319
- Autorebuild for GCC 4.3

* Thu Dec 13 2007 Dominik 'Rathann' Mierzejewski <rpm@greysector.net> 0.98-0.5
- more seamless variant handling
- use proper lam cflags and ldflags (as reported by pkgconfig)

* Tue Dec 04 2007 Dominik 'Rathann' Mierzejewski <rpm@greysector.net> 0.98-0.4
- add support for Alpha

* Wed Aug 29 2007 Dominik 'Rathann' Mierzejewski <rpm@greysector.net> 0.98-0.3
- rebuild
- update license tag

* Sat Jul 14 2007 Dominik 'Rathann' Mierzejewski <rpm@greysector.net> 0.98-0.2
- add support for ppc64 and sparc64, simplify target setting

* Sat Jul 07 2007 Dominik 'Rathann' Mierzejewski <rpm@greysector.net> 0.98-0.1
- update to 0.98 pre-release

* Sun Dec 17 2006 Dominik 'Rathann' Mierzejewski <rpm@greysector.net> 0.97-4
- fix copy&paste error in patch

* Sun Dec 17 2006 Dominik 'Rathann' Mierzejewski <rpm@greysector.net> 0.97-3
- add SPARC support

* Wed Nov 29 2006 Dominik 'Rathann' Mierzejewski <rpm@greysector.net> 0.97-2
- use only kosher CFLAGS
- fix target setting

* Tue Nov 28 2006 Dominik 'Rathann' Mierzejewski <rpm@greysector.net> 0.97-1
- initial build
- patch to add necessary build targets
